/////////////////////////////////////////////////////////////////////////////
// GliD3D.cpp : GliD3D - Glide to Direct3D
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Directive

#include "GliD3D.h"
#include <stdlib.h>


/////////////////////////////////////////////////////////////////////////////
// Defines / Variables

HWND g_gr_hWnd;
HWND g_gr_hWndOld;
HDC g_gr_hDC;
HGLRC g_gr_glRC;
INT g_gr_nWidth;
INT g_gr_nHeight;
BOOL g_gr_bOpenedWindow;

///BOOL g_gr_bUseZInverse;
///BOOL g_gr_bPrecisionFix;
///BOOL g_gr_bUseTexEnvBlend;
BOOL g_gr_bUseTexEnvAdd;
BOOL g_gr_bUseTexEnvCombine;
BOOL g_gr_bFullScreen;
//INT  g_gr_nDebug;

int			static_color_mode;
GL2IDE_COLOR	static_color;
BOOL			noTexColor;
BOOL			noTexAlpha;
int			combine_color_mode;
int			combine_alpha_mode;
int			flushDrawState;
GL2IDE_COLOR	texEnvColor;

GLID3D_TEXTURE *current_texture = &g_gr_tmu[0].texture[0];

BOOL		g_gr_Texture2DOn;
BOOL		g_gr_BlendOn;
BOOL		g_gr_AlphaTestOn;
GLint	g_gr_texenv;
GLint		f_texenv;
GrAlphaBlendFnc_t	f_alpha_blend_function_rgb_sf;
GrAlphaBlendFnc_t	f_alpha_blend_function_rgb_df;
GrCmpFnc_t	f_alpha_test_function;
GrAlpha_t	f_alpha_test_reference_value;
FxBool		f_depth_mask;
GrCmpFnc_t	f_depth_buffer_function;
GrCullMode_t	f_cull_mode;

VERTEX2	ptlv[3];

#ifdef USEVERTEXARRAY
GLsizei		ArrayCount;
GL2IDE_TEXCORD	TexCoordArray[MAXVERTEX];
GL2IDE_COLOR	ColorArray[MAXVERTEX];
CORD		CoordArray[MAXVERTEX];
#else
BOOL g_gr_DrawingTriangles;
#endif	//USEVERTEXARRAY

GLenum	src_blendmap[16], dst_blendmap[16];
GLfloat	div255_lookuptable[256];

GLID3D_STATE g_gr_state;
GLID3D_TMU g_gr_tmu[GLID3D_NUM_TMU];

/////////////////////////////////////////////////////////////////////////////
// Implements

BOOL
GliD3DGetProfileString (LPCSTR pszSection, LPCSTR pszKey, LPCSTR
	pszDefault, LPSTR pszDest, LPCSTR pszProfileName)
{
	GetPrivateProfileString (pszSection, pszKey, pszDefault, pszDest, 256, pszProfileName);
	return TRUE;
}

INT
GliD3DGetProfileInt (LPCSTR pszSection, LPCSTR pszKey, INT nDefault,
	LPCSTR pszProfileName)
{
	CHAR pszDefault[32];
	CHAR pszDest[32];
	INT nDest;
	BOOL bSucceeded;

	itoa (nDefault, pszDefault, 10);
	bSucceeded = GetPrivateProfileString (pszSection, pszKey, pszDefault,
		pszDest, 256, pszProfileName);
	nDest = atoi (pszDest);
	return nDest;
}

BOOL
GliD3DWriteProfileString (LPCSTR pszSection, LPCSTR pszKey, LPSTR pszSrc,
	LPCSTR pszProfileName)
{
	return WritePrivateProfileString (pszSection, pszKey, pszSrc, pszProfileName);
}

BOOL
GliD3DWriteProfileInt (LPCSTR pszSection, LPCSTR pszKey, INT nSrc,
	LPCSTR pszProfileName)
{
	CHAR pszSrc[32];

	itoa (nSrc, pszSrc, 10);
	return WritePrivateProfileString (pszSection, pszKey, pszSrc, pszProfileName);
}

/////////////////////////////////////////////////////////////////////////////
