/////////////////////////////////////////////////////////////////////////////
// GliD3D_Buffer.cpp : No comment
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Directive

#include "GliD3D.h"

/////////////////////////////////////////////////////////////////////////////
// Defines / Variables

/////////////////////////////////////////////////////////////////////////////
// Prototypes

/////////////////////////////////////////////////////////////////////////////
// Implements

FX_ENTRY void FX_CALL grBufferClear (GrColor_t color, GrAlpha_t alpha, FxU16 depth)
{
	TRACEFUNCTION ("grBufferClear");

	FlushTriangleVertex();
	DWORD cr = grsubConvColor (color);
	glClearColor (((cr & 0xff0000) >> 16)/255.0f,
		((cr & 0xff00) >>  8)/255.0f,
		(cr & 0xff)/255.0f,
		((cr & 0xff000000) >> 24)/255.0f);

	switch (g_gr_state.depth_buffer_mode)
	{
	case GR_DEPTHBUFFER_DISABLE:
		glClear (GL_COLOR_BUFFER_BIT);
		// Clear back buffer.
		break;
	case GR_DEPTHBUFFER_WBUFFER:
		glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		// Clear back buffer and W-buffer.
		break;
	case GR_DEPTHBUFFER_ZBUFFER:
		glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		// Clear back buffer and Z-buffer.
		break;
	}
}

FX_ENTRY int FX_CALL grBufferNumPending (void)
{
	TRACEFUNCTION ("grBufferNumPending");

	// First of all return 0.

	return 0;
}

FX_ENTRY void FX_CALL grBufferSwap (int swap_interval)
{
	TRACEFUNCTION ("grBufferSwap");
	FlushTriangleVertex();

	glFlush ();
	//glFinish ();
	SwapBuffers (g_gr_hDC);
/*
	if((err=glGetError())!= GL_NO_ERROR) {
		char tmp[2024];
		GLenum err;
		ofstream error("error.txt",ios::out | ios::app, 0); 
		sprintf(tmp, "%s", (char*)gluErrorString(err));
		error << tmp << endl;
		error.close();
	}
*/
#ifdef DEBUGDLL
	GLenum err;
	if((err=glGetError())!= GL_NO_ERROR) {
		char	mbuf[256];
		sprintf(mbuf, "glError : <%d>", err);	//(char*)gluErrorString(err));
		ERROROUT(mbuf);
	}
#endif	//DEBUGDLL
}

FX_ENTRY void FX_CALL grRenderBuffer (GrBuffer_t buffer)
{
	TRACEFUNCTION ("grRenderBuffer");
	//

	if (g_gr_state.render_buffer == buffer)
		return;
	FlushTriangleVertex();

	g_gr_state.render_buffer = buffer;
	switch (buffer)
	{
	case GR_BUFFER_FRONTBUFFER:
		glDrawBuffer (GL_FRONT);
		break;
	case GR_BUFFER_BACKBUFFER:
		glDrawBuffer (GL_BACK);
		break;
	}
	//glFlush ();
}

/////////////////////////////////////////////////////////////////////////////
