/////////////////////////////////////////////////////////////////////////////
// GliD3D_linearframebuffer.cpp : No comment
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Directive

#include "GliD3D.h"

/////////////////////////////////////////////////////////////////////////////
// Defines / Variables

/////////////////////////////////////////////////////////////////////////////
// Prototypes

/////////////////////////////////////////////////////////////////////////////
// Implements

FX_ENTRY FxBool FX_CALL
  grLfbLock (GrLock_t type, GrBuffer_t buffer, GrLfbWriteMode_t writeMode,
	GrOriginLocation_t origin, FxBool pixelPipeline,
	GrLfbInfo_t * info)
{
	TRACEFUNCTION ("grLfbLock");

	return FXTRUE;
}

FX_ENTRY FxBool FX_CALL
  grLfbUnlock (GrLock_t type, GrBuffer_t buffer)
{
	TRACEFUNCTION ("grLfbUnlock");

	return FXTRUE;
}

FX_ENTRY void FX_CALL grLfbConstantAlpha (GrAlpha_t alpha)
{
	TRACEFUNCTION ("grLfbConstantAlpha");
}

FX_ENTRY void FX_CALL grLfbConstantDepth (FxU16 depth)
{
	TRACEFUNCTION ("grLfbConstantDepth");
}

FX_ENTRY void FX_CALL grLfbWriteColorSwizzle (FxBool swizzleBytes, FxBool swapWords)
{
	TRACEFUNCTION ("grLfbWriteColorSwizzle");
}

FX_ENTRY void FX_CALL grLfbWriteColorFormat (GrColorFormat_t colorFormat)
{
	TRACEFUNCTION ("grLfbWriteColorFormat");
}

FX_ENTRY FxBool FX_CALL grLfbWriteRegion (GrBuffer_t dst_buffer, FxU32
	dst_x, FxU32 dst_y, GrLfbSrcFmt_t src_format, FxU32 src_width, FxU32 src_height,
	FxI32 src_stride, void *src_data)

{
	TRACEFUNCTION ("grLfbWriteRegion");

	return FXFALSE;
}

//#include <stdlib.h>

FX_ENTRY FxBool FX_CALL
  grLfbReadRegion (GrBuffer_t src_buffer,
	FxU32 src_x, FxU32 src_y,
	FxU32 src_width, FxU32 src_height,
	FxU32 dst_stride, void *dst_data)
{
	TRACEFUNCTION ("grLfbReadRegion");

#if 0	// glReadPixels() does not work. I don't know why.
	FlushTriangleVertex();

	switch (src_buffer)
	{
	case GR_BUFFER_FRONTBUFFER:
		glReadBuffer (GL_FRONT);
		break;
	case GR_BUFFER_BACKBUFFER:
		glReadBuffer (GL_BACK);
		break;
	}

	unsigned long		*lbuf = (unsigned long *)malloc(src_width * sizeof(*lbuf));

	for(unsigned long	i = 0; i < src_height; ++i){
		unsigned long	*src = lbuf;
		unsigned short	*dest = (unsigned short*)dst_data + dst_stride/sizeof(*dest)*i;

		glReadPixels(src_x, src_height - 1 - (src_y + i),
					 src_width, 1, GL_RGBA, GL_UNSIGNED_BYTE, src);

		for ( ; src < lbuf + src_width; ++src) {
			*dest++ = (unsigned short)(((*src & 0x000000f8) << 8) |
									   ((*src & 0x0000fc00) >> 5) |
									   ((*src & 0x00f80000) >> 19));
		}
	}
	free(lbuf);
#else
	for(unsigned long	y = 0; y < src_height; ++y){
		unsigned short	*dest = (unsigned short*)dst_data + dst_stride/sizeof(*dest)*y;

		for (unsigned long	x = 0; x < src_width; ++x) {
			const unsigned long	u = GetPixel(g_gr_hDC, src_x + x, src_y + y);
			*dest++ = (unsigned short)(((u & 0x000000f8) << 8) |
									   ((u & 0x0000fc00) >> 5) |
									   ((u & 0x00f80000) >> 19));
		}
	}
#endif
	return FXTRUE;
}

/////////////////////////////////////////////////////////////////////////////
